// Copyright (c) The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.

// Authors: Malolan Chetlur             mal@ececs.uc.edu
//          Jorgen Dahl                 dahlj@ececs.uc.edu
//          Dale E. Martin              dmartin@cliftonlabs.com
//          Radharamanan Radhakrishnan  ramanan@ececs.uc.edu
//          Dhananjai Madhava Rao       dmadhava@ececs.uc.edu
//          Philip A. Wilsey            phil.wilsey@uc.edu

//---------------------------------------------------------------------------
// 
// $Id: DecentralizedEventSetSchedulingManager.cpp
// 
//---------------------------------------------------------------------------

#include "DecentralizedEventSetSchedulingManager.h"
#include "TimeWarpDecentralizedEventSetFactory.h"


DecentralizedEventSetSchedulingManager::DecentralizedEventSetSchedulingManager( TimeWarpSimulationManager* simMgr) : 
  mySimulationManager(simMgr), 
  myEventSet( 0 ), 
  simulationObjectsArray( 0 ) {}

DecentralizedEventSetSchedulingManager::~DecentralizedEventSetSchedulingManager() {
  delete simulationObjectsArray;
}

void
DecentralizedEventSetSchedulingManager::initialize(TimeWarpEventSet *eventSet,
                                                   vector<SimulationObject*> *simObjArray){
  myEventSet = eventSet;
  ASSERT( myEventSet != 0 );
  // ownership of scheduler's list is transferred here.
  // the scheduler is now responsible for deleting this memory
  simulationObjectsArray = simObjArray;
}

